// Strings.cpp
#define UNICODE
#define _UNICODE
#include  <windows.h>
#include  "string.h"
#include  "stdio.h"
#include  "Strings.h"
#include  "tchar.h"


String operator+(TCHAR* lhs, String& rhs)    //global function
{
 String sr=lhs;
 sr=sr+rhs;

 return sr;
}


String::String()
{
 this->lpBuffer=new TCHAR[16];
 this->lpBuffer[0]=0;
 this->iLen=0;
 this->iCapacity=15;
}


String::String(const int iSize, bool blnFillNulls)  //Constructor Creates String With Custom Sized
{                                                   //Buffer (rounded up to paragraph boundary)
 int iNewSize      = (iSize/16+1)*16;
 this->lpBuffer    = new TCHAR[iNewSize];
 this->iCapacity   = iNewSize-1;
 this->iLen        = 0;
 this->lpBuffer[0] = _T('\0');
 if(blnFillNulls)
    memset(this->lpBuffer,0,iNewSize*sizeof(TCHAR));
}


String::String(const TCHAR ch)  //Constructor: Initializes with wchar_t
{
 this->iLen=1;
 int iNewSize=MINIMUM_ALLOCATION;
 this->lpBuffer=new TCHAR[iNewSize];
 this->iCapacity=iNewSize-1;
 this->lpBuffer[0]=ch, this->lpBuffer[1]=_T('\0');
}


String::String(const TCHAR* pStr)  //Constructor: Initializes with wchar_t*
{
 this->iLen=_tcslen(pStr);
 int iNewSize=(this->iLen/16+1)*16;
 this->lpBuffer=new TCHAR[iNewSize];
 this->iCapacity=iNewSize-1;
 _tcscpy(lpBuffer,pStr);
}


String::String(const String& s)  //Constructor Initializes With Another String, i.e., Copy Constructor
{
 int iNewSize=(s.iLen/16+1)*16;
 this->iLen=s.iLen;
 this->lpBuffer=new TCHAR[iNewSize];
 this->iCapacity=iNewSize-1;
 _tcscpy(this->lpBuffer,s.lpBuffer);
}


#ifdef INTEGRAL_CONVERSIONS
   String::String(int iNum)
   {
    this->lpBuffer=new TCHAR[16];
    this->iCapacity=15;
    this->iLen=_stprintf(this->lpBuffer,_T("%d"),iNum);
   }

   
   String::String(unsigned int iNum)
   {
    this->lpBuffer=new TCHAR[16];
    this->iCapacity=15;
    this->iLen=_stprintf(this->lpBuffer,_T("%u"),iNum);
   }
   
   
   #ifdef x64
      String::String(size_t iNum)
      {
       this->lpBuffer=new TCHAR[32];
       this->iCapacity=31;
       this->iLen=_stprintf(this->lpBuffer,_T("%Iu"),iNum);
      }


      String::String(ssize_t iNum)
      {
       this->lpBuffer=new TCHAR[32];
       this->iCapacity=31;
       this->iLen=_stprintf(this->lpBuffer,_T("%Id"),iNum);
      }
   #endif
#endif


#ifdef FLOATING_POINT_CONVERSIONS
   //String::String(double dblNumber)
   //{
   // this->lpBuffer=new TCHAR[24];
   // this->iCapacity=23;
   // this->iLen=FltToTch(this->lpBuffer,dblNumber,24,6,_T('.'),false);
   //}
   
   //String::String(double dblNumber)
   //{
   // char szBuffer[1024];

   // this->iLen=pSPrtf(szBuffer,"%16.8f",dblNumber);
   // int iNewSize=(this->iLen/16+1)*16;
   // this->lpBuffer=new char[iNewSize];
   // this->iCapacity=iNewSize-1;
   // strcpy(this->lpBuffer,szBuffer);
   //}
   String::String(double dblNumber)
   {
    this->lpBuffer=new TCHAR[24];
    this->iCapacity=23;
    this->iLen=_stprintf(this->lpBuffer,_T("%-23.6f"),dblNumber);
   }
#endif   


String& String::operator=(const TCHAR ch)
{
 this->lpBuffer[0]=ch, this->lpBuffer[1]=_T('\0');
 this->iLen=1;
 return *this;
}


String& String::operator=(const TCHAR* pStr)  // Assign TCHAR* to String
{
 size_t iNewLen=_tcslen(pStr);
 if(iNewLen>this->iCapacity)
 {
    delete [] this->lpBuffer;
    int iNewSize=(iNewLen*EXPANSION_FACTOR/16+1)*16;
    this->lpBuffer=new TCHAR[iNewSize];
    this->iCapacity=iNewSize-1;
 }
 _tcscpy(this->lpBuffer,pStr);
 this->iLen=iNewLen;
   
 return *this;
}


String& String::operator=(const String& strAnother)
{
 if(this==&strAnother)
    return *this;
 if(strAnother.iLen>this->iCapacity)
 {
    delete [] this->lpBuffer;
    int iNewSize=(strAnother.iLen*EXPANSION_FACTOR/16+1)*16;
    this->lpBuffer=new TCHAR[iNewSize];
    this->iCapacity=iNewSize-1;
 }
 _tcscpy(this->lpBuffer,strAnother.lpBuffer);
 this->iLen=strAnother.iLen;

 return *this;
}


#ifdef INTEGRAL_CONVERSIONS
   #ifdef x64
      String& String::operator=(size_t iNum)
      {
       if(this->iCapacity>=24)
          this->iLen=_stprintf(this->lpBuffer,_T("%Iu"),iNum);
       else
       {
          delete [] this->lpBuffer;
          this->lpBuffer=new TCHAR[24];
          this->iCapacity=23;
          this->iLen=_stprintf(this->lpBuffer,_T("%Iu"),iNum);
       }

       return *this;
      }


      String& String::operator=(ssize_t iNum)
      {
       if(this->iCapacity>=32)
          this->iLen=_stprintf(this->lpBuffer,_T("%Id"),iNum);
       else
       {
          delete [] this->lpBuffer;
          this->lpBuffer=new TCHAR[24];
          this->iCapacity=23;
          this->iLen=_stprintf(this->lpBuffer,_T("%Id"),iNum);
       }

       return *this;
      }
   #endif


   String& String::operator=(int iNum)
   {
    if(this->iCapacity>=15)
       this->iLen=_stprintf(this->lpBuffer,_T("%d"),iNum); 
    else
    {
       delete [] this->lpBuffer;
       this->lpBuffer=new TCHAR[16];
       this->iCapacity=15;
       this->iLen=_stprintf(this->lpBuffer,_T("%d"),iNum);
    }

    return *this;
   }


   String& String::operator=(unsigned int iNum)
   {
    if(this->iCapacity>=15)
       this->iLen=_stprintf(this->lpBuffer,_T("%u"),iNum);
    else
    {
       delete [] this->lpBuffer;
       this->lpBuffer=new TCHAR[16];
       this->iCapacity=15;
       this->iLen=_stprintf(this->lpBuffer,_T("%u"),iNum);
    }

    return *this;
   }
#endif


#ifdef FLOATING_POINT_CONVERSIONS
   //String& String::operator=(double dblNumber)
   //{
   // if(this->iCapacity>=24)
   //    this->iLen=FltToTch(this->lpBuffer,dblNumber,24,6,_T('.'),false);
   // else
   // {
   //    delete [] this->lpBuffer;
   //    this->lpBuffer=new TCHAR[24];
   //    this->iLen=FltToTch(this->lpBuffer,dblNumber,24,6,_T('.'),false);
   //    this->iCapacity=23;
   // }

   // return *this;
   //}
   
   //String& String::operator=(double dblNumber)
   //{
   // char szBuffer[1024];

   // this->iLen=pSPrtf(szBuffer,"%16.8f",dblNumber);
   // int iNewSize=(this->iLen/16+1)*16;
   // this->lpBuffer=new char[iNewSize];
   // this->iCapacity=iNewSize-1;
   // strcpy(this->lpBuffer,szBuffer);

   // return *this;
   //}
   
   String& String::operator=(double dblNumber)
   {
    if(this->iCapacity>=24)
       this->iLen=_stprintf(this->lpBuffer,_T("%-23.6f"),dblNumber);
    else
    { 
       delete [] this->lpBuffer;
       this->lpBuffer=new TCHAR[24];
       this->iCapacity=23;
       this->iLen=_stprintf(this->lpBuffer,_T("%-23.6f"),dblNumber);
    } 

    return *this;    
   }
#endif
   

String String::operator+(const TCHAR ch)
{
 int iNewLen=this->iLen+1;

 String s(iNewLen,false);
 _tcscpy(s.lpBuffer,this->lpBuffer);
 s.lpBuffer[iNewLen-1]=ch;
 s.lpBuffer[iNewLen]=_T('\0');
 s.iLen=iNewLen;

 return s;
}


String String::operator+(const TCHAR* pStr)
{
 int iNewLen=_tcslen(pStr)+this->iLen;
 String s(iNewLen,false);
 _tcscpy(s.lpBuffer,this->lpBuffer);
 _tcscat(s.lpBuffer,pStr);
 s.iLen=iNewLen;

 return s;
}


String String::operator+(String& strRef)
{
 int iNewLen=strRef.iLen+this->iLen;
 String s(iNewLen,false);
 _tcscpy(s.lpBuffer,this->lpBuffer);
 _tcscat(s.lpBuffer,strRef.lpBuffer);
 s.iLen=iNewLen;

 return s;
}


#ifdef PLUS_EQUAL
   String& String::operator+=(const TCHAR ch)
   {
    size_t iTot=this->iLen+1;
    if(iTot>this->iCapacity)
    {
       int iNewSize=(iTot*EXPANSION_FACTOR/16+1)*16;
       TCHAR* pNew=new TCHAR[iNewSize];
       _tcscpy(pNew,this->lpBuffer);
       delete [] this->lpBuffer;
       this->lpBuffer=pNew;
       this->lpBuffer[iTot-1]=ch;
       this->lpBuffer[iTot]=_T('\0');
       this->iCapacity=iNewSize-1;
       this->iLen=iTot;
    }
    else
    {
       this->lpBuffer[iTot-1]=ch;
       this->lpBuffer[iTot]=_T('\0');
       this->iLen=iTot;
    }

    return *this;
   }


   String& String::operator+=(const TCHAR* pStr)
   {
    size_t iStrlen=_tcslen(pStr);
    size_t iTot=iStrlen+this->iLen;
    if(iTot>this->iCapacity)
    {
       int iNewSize=(iTot*EXPANSION_FACTOR/16+1)*16;
       TCHAR* pNew=new TCHAR[iNewSize];
       _tcscpy(pNew,this->lpBuffer);
       delete [] this->lpBuffer;
       this->lpBuffer=pNew;
       _tcscat(pNew,pStr);
       this->iCapacity=iNewSize-1;
       this->iLen=iTot;
    }
    else
    {
       _tcscat(this->lpBuffer,pStr);
       this->iLen=iTot;
    }

    return *this;
   }


   String& String::operator+=(const String& strRef)
   {
    size_t iTot=strRef.iLen+this->iLen;
    if(iTot>this->iCapacity)
    {
       int iNewSize=(iTot*EXPANSION_FACTOR/16+1)*16;
       TCHAR* pNew=new TCHAR[iNewSize];
       _tcscpy(pNew,this->lpBuffer);
       delete [] this->lpBuffer;
       this->lpBuffer=pNew;
       _tcscat(pNew,strRef.lpBuffer);
       this->iCapacity=iNewSize-1;
       this->iLen=iTot;
    }
    else
    {
       _tcscat(this->lpBuffer,strRef.lpBuffer);
       this->iLen=iTot;
    }

    return *this;
   }
#endif


bool String::operator==(String strRef)
{
 if(_tcscmp(this->lpStr(),strRef.lpStr())==0)
    return true;
 else
    return false;
}


bool String::operator==(const TCHAR* pStr)
{
 if(_tcscmp(this->lpStr(),pStr)==0)
    return true;
 else
    return false;
}


bool String::operator!=(TCHAR* pStr)
{
 if(_tcscmp(this->lpStr(),pStr)==0)
    return false;
 else
    return true;
}


String String::Left(size_t iNum)   //  strncpy = _tcsncpy
{
 if(iNum<this->iLen)
 {
    size_t iNewSize=(iNum*EXPANSION_FACTOR/16+1)*16;
    String sr(iNewSize,true);
    _tcsncpy(sr.lpBuffer,this->lpBuffer,iNum);   // wcsncpy(wchar_t pDest, wchar_t pSource, size_t iCount);
    sr.lpBuffer[iNum]=_T('\0');
    sr.iLen=iNum;
    return sr;
 }
 else
 {
    String sr=*this;
    sr.iLen=this->iLen;
    return sr;
 }
}


String String::Right(size_t iNum)  //Returns Right$(strMain,iNum)
{
 if(iNum<this->iLen)
 {
    size_t iNewSize=(iNum*EXPANSION_FACTOR/16+1)*16;
    String sr(iNewSize,false);
    _tcsncpy(sr.lpBuffer,this->lpBuffer+this->iLen-iNum,iNum);
    sr.lpBuffer[iNum]=_T('\0');
    sr.iLen=iNum;
    return sr;
 }
 else
 {
    String sr=*this;
    sr.iLen=this->iLen;
    return sr;
 }
}


String String::Mid(size_t iStart, size_t iCount)
{
 if(iStart<1)
 {
    String sr;
    return sr;
 }
 if(iCount+iStart>this->iLen)
    iCount=this->iLen-iStart+1;
 String sr(iCount,false);
 _tcsncpy(sr.lpBuffer,this->lpBuffer+iStart-1,iCount);
 sr.lpBuffer[iCount]=_T('\0');
 sr.iLen=iCount;

 return sr;
}


void String::LTrim()
{
 size_t iCt=0;

 for(size_t i=0; i<this->iLen; i++)
 {
     if(this->lpBuffer[i]==9||this->lpBuffer[i]==10||this->lpBuffer[i]==13||this->lpBuffer[i]==32)
        iCt++;
     else
        break;
 }
 if(iCt)
 {
    for(size_t i=iCt; i<=this->iLen; i++)
        this->lpBuffer[i-iCt]=this->lpBuffer[i];
 }
 this->iLen=this->iLen-iCt;
}


void String::RTrim()
{
 int iCt=0;

 for(int i=this->iLen-1; i>0; i--)
 {
     if(this->lpBuffer[i]==9||this->lpBuffer[i]==10||this->lpBuffer[i]==13||this->lpBuffer[i]==32)
        iCt++;
     else
        break;
 }
 this->lpBuffer[this->iLen-iCt]=0;
 this->iLen=this->iLen-iCt;
}


void String::Trim()
{
 this->LTrim();
 this->RTrim();
}


int String::ParseCount(const TCHAR delimiter)   //returns one more than # of
{                                               //delimiters so it accurately
 int iCtr=0;                                    //reflects # of strings delimited
 TCHAR* p;                                      //by delimiter.

 p=this->lpBuffer;
 while(*p)
 {
   if(*p==delimiter)
      iCtr++;
   p++;
 }

 return ++iCtr;
}


void String::Parse(String* pStr, TCHAR delimiter, size_t iParseCount)
{
 TCHAR* pBuffer=new TCHAR[this->iLen+1];
 if(pBuffer)
 {
    TCHAR* p=pBuffer;
    TCHAR* c=this->lpBuffer;
    while(*c)
    {
       if(*c==delimiter)
          *p=0;
       else
          *p=*c;
       p++, c++;
    }
    *p=0, p=pBuffer;
    for(size_t i=0; i<iParseCount; i++)
    {
        pStr[i]=p;
        p=p+pStr[i].iLen+1;
    }
    delete [] pBuffer;
 }
}


int iMatch(TCHAR* pThis, const TCHAR* pStr, bool blnCaseSensitive, bool blnStartBeginning, int i, int iParamLen)
{
 if(blnCaseSensitive)
 {
    if(_tcsncmp(pThis+i,pStr,iParamLen)==0)   //_tcsncmp
       return i+1;
    else
       return 0;
 }
 else
 {
    if(_tcsnicmp(pThis+i,pStr,iParamLen)==0)  //__tcsnicmp
       return i+1;
    else
       return 0;
 }
}


int String::InStr(const TCHAR* pStr, bool blnCaseSensitive, bool blnStartBeginning)
{
 int i,iParamLen,iRange,iReturn;

 if(*pStr==0)
    return 0;
 iParamLen=_tcslen(pStr);
 iRange=this->iLen-iParamLen;
 if(blnStartBeginning)
 {
    if(iRange>=0)
    {
       for(i=0; i<=iRange; i++)
       {
           iReturn=iMatch(this->lpBuffer,pStr,blnCaseSensitive,blnStartBeginning,i,iParamLen);
           if(iReturn)
              return iReturn;
       }
    }
 }
 else
 {
    if(iRange>=0)
    {
       for(i=iRange; i>=0; i--)
       {
           iReturn=iMatch(this->lpBuffer,pStr,blnCaseSensitive,blnStartBeginning,i,iParamLen);
           if(iReturn)
              return iReturn;
       }
    }
 }

 return 0;
}


int String::InStr(const String& s, bool blnCaseSensitive, bool blnStartBeginning)
{
 int i,iParamLen,iRange,iReturn;

 if(s.iLen==0)
    return 0;
 iParamLen=s.iLen;
 iRange=this->iLen-iParamLen;
 if(blnStartBeginning)
 {
    if(iRange>=0)
    {
       for(i=0; i<=iRange; i++)
       {
           iReturn=iMatch(this->lpBuffer,s.lpBuffer,blnCaseSensitive,blnStartBeginning,i,iParamLen);
           if(iReturn)
              return iReturn;
       }
    }
 }
 else
 {
    if(iRange>=0)
    {
       for(i=iRange; i>=0; i--)
       {
           iReturn=iMatch(this->lpBuffer,s.lpBuffer,blnCaseSensitive,blnStartBeginning,i,iParamLen);
           if(iReturn)
              return iReturn;
       }
    }
 }

 return 0;
}


String String::Remove(const TCHAR* pStr) // Individual character removal, i.e., if this contains the
{                                        // English alphabet...
 unsigned int i,j,iStrLen,iParamLen;     //
 TCHAR *pThis, *pThat, *p;               // abcdefghijklmnopqrstuvwxyz
 bool blnFoundBadTCHAR;                  //
                                         // ...and pStr is this...
 iStrLen=this->iLen;                     // 
 String sr((int)iStrLen,false);          // "aeiou"
 iParamLen=_tcslen(pStr);                // 
 pThis=this->lpBuffer;                   // ,,,then this will be returned in the returned String...
 p=sr.lpStr();                           //
 for(i=0; i<iStrLen; i++)                // bcdfghjklmnpqrstvwxyz
 {                                       //
     pThat=(TCHAR*)pStr;                 // That is, the vowels will be individually removed
     blnFoundBadTCHAR=false;
     for(j=0; j<iParamLen; j++)
     {
         if(*pThis==*pThat)
         {
            blnFoundBadTCHAR=true;
            break;
         }
         pThat++;
     }
     if(!blnFoundBadTCHAR)
     {
        *p=*pThis;
        p++;
        *p=_T('\0');
     }
     pThis++;
 }
 sr.iLen=_tcslen(sr.lpStr());

 return sr;
}


String String::Remove(const TCHAR* pMatch, bool blnCaseSensitive)
{
 size_t i,iCountMatches=0,iCtr=0;

 size_t iLenMatch=_tcslen(pMatch);
 for(i=0; i<this->iLen; i++)
 {
     if(blnCaseSensitive)
     {
        if(_tcsncmp(lpBuffer+i,pMatch,iLenMatch)==0)  //_tcsncmp
           iCountMatches++;
     }
     else
     {
        if(_tcsnicmp(lpBuffer+i,pMatch,iLenMatch)==0) //__tcsnicmp
           iCountMatches++;
     }
 }
 int iAllocation=this->iLen-(iCountMatches*iLenMatch);
 String sr(iAllocation,false);
 for(i=0; i<this->iLen; i++)
 {
     if(blnCaseSensitive)
     {
        if(_tcsncmp(this->lpBuffer+i,pMatch,iLenMatch)==0)
           i+=iLenMatch-1;
        else
        {
           sr.lpBuffer[iCtr]=this->lpBuffer[i];
           iCtr++;
        }
        sr.lpBuffer[iCtr]=_T('\0');
     }
     else
     {
        if(_tcsnicmp(this->lpBuffer+i,pMatch,iLenMatch)==0)
           i+=iLenMatch-1;
        else
        {
           sr.lpBuffer[iCtr]=this->lpBuffer[i];
           iCtr++;
        }
        sr.lpBuffer[iCtr]=_T('\0');
     }
 }
 sr.iLen=iCtr;
 return sr;
}


String String::Replace(TCHAR* pMatch, TCHAR* pNew)  //strncmp = _tcsncmp
{
 size_t i,iLenMatch,iLenNew,iCountMatches,iExtra,iExtraLengthNeeded,iAllocation,iCtr;
 iLenMatch=_tcslen(pMatch);
 iCountMatches=0, iAllocation=0, iCtr=0;
 iLenNew=_tcslen(pNew);
 if(iLenNew==0)
 {
    String sr=this->Remove(pMatch,true); //return
    return sr;
 }
 else
 {
    iExtra=iLenNew-iLenMatch;
    for(i=0; i<this->iLen; i++)
    {
        if(_tcsncmp(lpBuffer+i,pMatch,iLenMatch)==0)
           iCountMatches++;  //Count how many match strings
    }
    iExtraLengthNeeded=iCountMatches*iExtra;
    iAllocation=this->iLen+iExtraLengthNeeded;
    String sr(iAllocation,false);
    for(i=0; i<this->iLen; i++)
    {
        if(_tcsncmp(this->lpBuffer+i,pMatch,iLenMatch)==0)
        {
           _tcscpy(sr.lpBuffer+iCtr,pNew);
           iCtr+=iLenNew;
           i+=iLenMatch-1;
        }
        else
        {
           sr.lpBuffer[iCtr]=this->lpBuffer[i];
           iCtr++;
        }
        sr.lpBuffer[iCtr]=_T('\0');
    }
    sr.iLen=iCtr;
    return sr;
 }
}


#ifdef FORMATTING
   void String::Format(double dblNumber, size_t iFieldSize, size_t iDecPlaces, TCHAR cDecimalSeperator, bool blnRightJustified)
   {
    String strFldSpec,strDecPlaces,strFldSize;
    
    //printf("  Entering String::Format(Simpler)\n");
    //printf("    dblNumber       = %24.8f\n",dblNumber);
    //printf("    iFieldSize      = %Iu\n",iFieldSize);
    //printf("    this->iCapacity = %Iu\n",this->iCapacity);   
    strFldSpec=_T('%');
    strFldSize=iFieldSize;
    strDecPlaces=iDecPlaces;
    if(blnRightJustified)
       strFldSpec=strFldSpec+strFldSize+cDecimalSeperator+strDecPlaces;
    else
       strFldSpec=strFldSpec+_T('-')+strFldSize+cDecimalSeperator+strDecPlaces;
    strFldSpec=strFldSpec+_T('f');
    //strFldSpec.Print(_T("    strFldSpec      = "),true);
    if(this->iCapacity<iFieldSize)
    {
       //printf("    Need To Reallocate!\n");
       delete [] this->lpBuffer;
       this->lpBuffer=new TCHAR[iFieldSize+1];
       this->iCapacity=iFieldSize;
       //printf("    this->iCapacity = %Iu\n",this->iCapacity);
    }   
    this->iLen=_stprintf(this->lpBuffer,strFldSpec.lpStr(),dblNumber);
    //printf("  Leaving String::Format(Simpler)\n");
   }
   
   
   void String::Format(double dblNumber, size_t iFieldSize, size_t iDecimalPlaces, TCHAR cThousandsSeperator, TCHAR cDecimalSeperator, bool blnRightJustified)
   {
    size_t iLen=0,iPadding=0;
    int iDecPt=0;
    _int64 iInt;
    
    //printf("Entering String::Format(Big Complicated)\n");
    //printf("  dblNumber = %32.8f\n",dblNumber);
    //printf("  iFieldSize      = %Iu\n",iFieldSize);
    //printf("  iDecimalPlaces  = %Iu\n",iDecimalPlaces);
    //printf("  this->iCapacity = %Iu\n",this->iCapacity);   
    if(this->iCapacity<iFieldSize+1)
    { 
       //printf("  Need To Reallocate!\n");
       delete [] this->lpBuffer;
       size_t iNewSize=(iFieldSize/16+1)*16;
       //printf("  iNewSize        = %Iu\n",iNewSize);
       this->lpBuffer=new TCHAR[iNewSize];
       this->iCapacity=iNewSize-1;
       this->lpBuffer[0]=0;
    }
    String s1(24,true);
    s1.Format(dblNumber,24,iDecimalPlaces,cDecimalSeperator,false); 
    s1.Trim();
    //s1.Print(_T("  "),true);
    if(iDecimalPlaces)
    { 
       iDecPt=s1.InStr(cDecimalSeperator,false,false);
       String s2=s1.Left(iDecPt-1);
       iInt=_ttoi64(s2.lpStr());
    }
    else
       iInt=_ttoi64(s1.lpStr());
    String s3(28,true);
    if(iInt==0 && dblNumber<0.0)
       s3=_T("-0");
    else
       s3.Format((ssize_t)iInt,28,cThousandsSeperator,false);
    s3.Trim();
    //_tprintf(_T("  %s\n"),s3.lpStr());
    //printf("  s3.Len()   = %Iu\n",s3.Len());
    if(iDecimalPlaces)
       s3=s3+s1.Mid(iDecPt,iDecimalPlaces+1);
    iLen=s3.Len();
    //printf("  iLen       = %Iu\n",iLen);
    //printf("  s3.Len()   = %Iu\n",s3.Len());
    if(iLen>this->iCapacity)
       return;
    iPadding=iFieldSize-iLen;
    //printf("  iPadding   = %Iu\n",iPadding);
    if(blnRightJustified)
    {
       for(size_t i=0; i<iPadding; i++)
           this->lpBuffer[i]=32; 
       this->lpBuffer[iPadding]=0;
       _tcscat(this->lpBuffer, s3.lpStr());  
    }
    else
    {
       _tcscpy(this->lpBuffer,s3.lpStr());
       for(size_t i=iLen; i<iFieldSize; i++)
           this->lpBuffer[i]=32;
       this->lpBuffer[iFieldSize]=0;   
       //printf("\n");
       //for(size_t i=0; i<this->iCapacity; i++)
       //    _tprintf(_T("  %Iu\t%d\t%c\n"),i,this->lpBuffer[i],this->lpBuffer[i]);
    } 
    this->iLen=_tcslen(this->lpBuffer);
    //printf("Leaving String::Format(Big Complicated)\n");    
   }
   
 
   void String::Format(ssize_t iNumber, size_t iFieldSize, TCHAR cThousandsSeperator, bool blnRightJustified)
   {
    bool blnPositive;
    TCHAR szBuf1[28];
    TCHAR szBuf2[28];
    size_t iDigit=0;
    size_t iLen=0;
    size_t iCtr=1;
    size_t j=0;

    //printf("  Entering String::Format(ssize_t)\n");
    //printf("    iNumber         = %Id\n",iNumber);
    //printf("    iFieldSize      = %Iu\n",iFieldSize);
    memset(szBuf1,0,28*sizeof(TCHAR));
    memset(szBuf2,0,28*sizeof(TCHAR));
    if(iNumber<0)
       blnPositive=false;
    else
       blnPositive=true;
    #ifdef x64
       iNumber=_abs64(iNumber);
    #else
       iNumber=abs(iNumber);
    #endif
    #ifdef x64
       _stprintf(szBuf1,_T("%Iu"),(size_t)iNumber);
    #else
       _stprintf(szBuf1,_T("%u"),(size_t)iNumber);
    #endif
    _tcsrev(szBuf1);
    iLen=_tcslen(szBuf1);
    for(size_t i=0; i<iLen; i++)
    {
        if(iCtr==3)
        {
           iDigit++;
           szBuf2[j]=szBuf1[i];
           if(iDigit<iLen)
           {
              j++;
              szBuf2[j]=cThousandsSeperator;
           }
           j++, iCtr=1;
        }
        else
        {
           iDigit++;
           szBuf2[j]=szBuf1[i];
           j++, iCtr++;
        }
    }
    _tcsrev(szBuf2); // Done With Creating String With Commas
    memset(szBuf1,0,28*sizeof(TCHAR));  // Reuse szBuf1
    if(blnPositive)
       _tcscpy(szBuf1,szBuf2);
    else
    {
       szBuf1[0]=_T('-');
       _tcscat(szBuf1,szBuf2);
    }   
    size_t iRequiredBytes;         // Find out which of two is larger - length of string necessary
    iLen=_tcslen(szBuf1);          // or iFldLen
    //_tprintf(_T("    szBuf1          = %s\n"),szBuf1);
    //printf("    iLen            = %Iu\n",iLen);
    //printf("    this->iCapacity = %Iu\n",this->iCapacity);
    if(iFieldSize<iLen)
       return;
    iRequiredBytes=iFieldSize+1;
    //printf("    iRequiredBytes  = %Iu\n",iRequiredBytes);  
    if(iRequiredBytes>(size_t)this->iCapacity)
    {
       //printf("    Need To Re-Allocate???\n");
       delete [] this->lpBuffer;
       int iNewSize=(iRequiredBytes*EXPANSION_FACTOR/16+1)*16;
       this->lpBuffer=new TCHAR[iNewSize];
       this->iCapacity=iNewSize-1;
       //printf("    iNewSize      = %Iu\n",iNewSize);
       //printf("    this->iCapacity = %Iu\n",this->iCapacity);
    }
    
    memset(this->lpBuffer,0,(this->iCapacity+1)*sizeof(TCHAR));  
    ssize_t iDifference=iFieldSize-iLen;
    //printf("    iDifference     = %Id\n",iDifference);
    if(blnRightJustified)                                             
    {
       if(iDifference > 0)
       {
          for(size_t i=0; i<(size_t)iDifference; i++)
              this->lpBuffer[i]=_T(' ');  // 32
       }
       _tcscat(this->lpBuffer,szBuf1);
    }
    else
    {
       _tcscpy(this->lpBuffer,szBuf1);
       if(iDifference>0)
       {
          for(size_t i=iLen; i<iDifference+iLen; i++)
              this->lpBuffer[i]=_T(' ');  // 32
       }
    }
    this->iLen=_tcslen(this->lpBuffer);
    //printf("  Leaving String::Format(ssize_t)\n");
   }
#endif


String String::UCase()
{
 String s(*this);
 CharUpper(s.lpBuffer);
 return s;
}


TCHAR* String::lpStr()
{
 return this->lpBuffer;
}


size_t String::Len(void)
{
 return this->iLen;
}


size_t String::Capacity(void)
{
 return this->iCapacity;
}


#ifdef CONSOLE_OUTPUT 
   void String::Print(bool blnCrLf)
   {
    _tprintf(_T("%s"),this->lpBuffer);
    if(blnCrLf)
       _tprintf(_T("\n"));
   }

   
   void String::Print(const TCHAR* pStr, bool blnCrLf)
   {
    _tprintf(_T("%s%s"),pStr,lpBuffer);
    if(blnCrLf)
       _tprintf(_T("\n"));
   }
#endif


String::~String()
{
 delete [] this->lpBuffer;
}
// End Strings.cpp

















/*
#ifdef FORMATTING
   void String::Format(double dblNumber, size_t iFieldSize, size_t iDecPlaces, TCHAR cDecimalSeperator, bool blnRightJustified)
   {
    String strFldSpec,strDecPlaces,strFldSize;
    
    printf("  Entering String::Format(Simpler)\n");
    printf("    dblNumber       = %24.8f\n",dblNumber);
    printf("    iFieldSize      = %Iu\n",iFieldSize);
    printf("    this->iCapacity = %Iu\n",this->iCapacity);   
    strFldSpec=_T('%');
    strFldSize=iFieldSize;
    strDecPlaces=iDecPlaces;
    if(blnRightJustified)
       strFldSpec=strFldSpec+strFldSize+cDecimalSeperator+strDecPlaces;
    else
       strFldSpec=strFldSpec+_T('-')+strFldSize+cDecimalSeperator+strDecPlaces;
    strFldSpec=strFldSpec+_T('f');
    strFldSpec.Print(_T("    strFldSpec      = "),true);
    if(this->iCapacity<iFieldSize)
    {
       printf("    Need To Reallocate!\n");
       delete [] this->lpBuffer;
       this->lpBuffer=new TCHAR[iFieldSize+1];
       this->iCapacity=iFieldSize;
       printf("    this->iCapacity = %Iu\n",this->iCapacity);
    }   
    this->iLen=_stprintf(this->lpBuffer,strFldSpec.lpStr(),dblNumber);
    printf("  Leaving String::Format(Simpler)\n");
   }
   
   
   void String::Format(double dblNumber, size_t iFieldSize, size_t iDecimalPlaces, TCHAR cThousandsSeperator, TCHAR cDecimalSeperator, bool blnRightJustified)
   {
    size_t iLen=0,iPadding=0;
    int iDecPt=0;
    _int64 iInt;
    
    printf("Entering String::Format(Big Complicated)\n");
    printf("  dblNumber = %32.8f\n",dblNumber);
    printf("  iFieldSize      = %Iu\n",iFieldSize);
    printf("  iDecimalPlaces  = %Iu\n",iDecimalPlaces);
    printf("  this->iCapacity = %Iu\n",this->iCapacity);   
    if(this->iCapacity<iFieldSize+1)
    { 
       printf("  Need To Reallocate!\n");
       delete [] this->lpBuffer;
       size_t iNewSize=(iFieldSize/16+1)*16;
       printf("  iNewSize        = %Iu\n",iNewSize);
       this->lpBuffer=new TCHAR[iNewSize];
       this->iCapacity=iNewSize-1;
       this->lpBuffer[0]=0;
    }
    String s1(24,true);
    s1.Format(dblNumber,24,iDecimalPlaces,cDecimalSeperator,false); 
    s1.Trim();
    s1.Print(_T("  "),true);
    if(iDecimalPlaces)
    { 
       iDecPt=s1.InStr(cDecimalSeperator,false,false);
       String s2=s1.Left(iDecPt-1);
       iInt=_ttoi64(s2.lpStr());
    }
    else
       iInt=_ttoi64(s1.lpStr());
    String s3(28,true);
    if(iInt==0 && dblNumber<0.0)
       s3=_T("-0");
    else
       s3.Format((ssize_t)iInt,28,cThousandsSeperator,false);
    s3.Trim();
    _tprintf(_T("  %s\n"),s3.lpStr());
    printf("  s3.Len()   = %Iu\n",s3.Len());
    if(iDecimalPlaces)
       s3=s3+s1.Mid(iDecPt,iDecimalPlaces+1);
    iLen=s3.Len();
    printf("  iLen       = %Iu\n",iLen);
    printf("  s3.Len()   = %Iu\n",s3.Len());
    if(iLen>this->iCapacity)
       return;
    iPadding=iFieldSize-iLen;
    printf("  iPadding   = %Iu\n",iPadding);
    if(blnRightJustified)
    {
       for(size_t i=0; i<iPadding; i++)
           this->lpBuffer[i]=32; 
       this->lpBuffer[iPadding]=0;
       _tcscat(this->lpBuffer, s3.lpStr());  
    }
    else
    {
       _tcscpy(this->lpBuffer,s3.lpStr());
       for(size_t i=iLen; i<iFieldSize; i++)
           this->lpBuffer[i]=32;
       this->lpBuffer[iFieldSize]=0;   
       //printf("\n");
       //for(size_t i=0; i<this->iCapacity; i++)
       //    _tprintf(_T("  %Iu\t%d\t%c\n"),i,this->lpBuffer[i],this->lpBuffer[i]);
    } 
    this->iLen=_tcslen(this->lpBuffer);
    printf("Leaving String::Format(Big Complicated)\n");    
   }
   
 
   void String::Format(ssize_t iNumber, size_t iFieldSize, TCHAR cThousandsSeperator, bool blnRightJustified)
   {
    bool blnPositive;
    TCHAR szBuf1[28];
    TCHAR szBuf2[28];
    size_t iDigit=0;
    size_t iLen=0;
    size_t iCtr=1;
    size_t j=0;

    printf("  Entering String::Format(ssize_t)\n");
    printf("    iNumber         = %Id\n",iNumber);
    printf("    iFieldSize      = %Iu\n",iFieldSize);
    memset(szBuf1,0,28*sizeof(TCHAR));
    memset(szBuf2,0,28*sizeof(TCHAR));
    if(iNumber<0)
       blnPositive=false;
    else
       blnPositive=true;
    #ifdef x64
       iNumber=_abs64(iNumber);
    #else
       iNumber=abs(iNumber);
    #endif
    #ifdef x64
       _stprintf(szBuf1,_T("%Iu"),(size_t)iNumber);
    #else
       _stprintf(szBuf1,_T("%u"),(size_t)iNumber);
    #endif
    _tcsrev(szBuf1);
    iLen=_tcslen(szBuf1);
    for(size_t i=0; i<iLen; i++)
    {
        if(iCtr==3)
        {
           iDigit++;
           szBuf2[j]=szBuf1[i];
           if(iDigit<iLen)
           {
              j++;
              szBuf2[j]=cThousandsSeperator;
           }
           j++, iCtr=1;
        }
        else
        {
           iDigit++;
           szBuf2[j]=szBuf1[i];
           j++, iCtr++;
        }
    }
    _tcsrev(szBuf2); // Done With Creating String With Commas
    memset(szBuf1,0,28*sizeof(TCHAR));  // Reuse szBuf1
    if(blnPositive)
       _tcscpy(szBuf1,szBuf2);
    else
    {
       szBuf1[0]=_T('-');
       _tcscat(szBuf1,szBuf2);
    }   
    size_t iRequiredBytes;         // Find out which of two is larger - length of string necessary
    iLen=_tcslen(szBuf1);          // or iFldLen
    _tprintf(_T("    szBuf1          = %s\n"),szBuf1);
    printf("    iLen            = %Iu\n",iLen);
    printf("    this->iCapacity = %Iu\n",this->iCapacity);
    if(iFieldSize<iLen)
       return;
    iRequiredBytes=iFieldSize+1;
    printf("    iRequiredBytes  = %Iu\n",iRequiredBytes);  
    if(iRequiredBytes>(size_t)this->iCapacity)
    {
       //printf("    Need To Re-Allocate???\n");
       delete [] this->lpBuffer;
       int iNewSize=(iRequiredBytes*EXPANSION_FACTOR/16+1)*16;
       this->lpBuffer=new TCHAR[iNewSize];
       this->iCapacity=iNewSize-1;
       //printf("    iNewSize      = %Iu\n",iNewSize);
       //printf("    this->iCapacity = %Iu\n",this->iCapacity);
    }
    
    memset(this->lpBuffer,0,(this->iCapacity+1)*sizeof(TCHAR));  
    ssize_t iDifference=iFieldSize-iLen;
    printf("    iDifference     = %Id\n",iDifference);
    if(blnRightJustified)                                             
    {
       if(iDifference > 0)
       {
          for(size_t i=0; i<(size_t)iDifference; i++)
              this->lpBuffer[i]=_T(' ');  // 32
       }
       _tcscat(this->lpBuffer,szBuf1);
    }
    else
    {
       _tcscpy(this->lpBuffer,szBuf1);
       if(iDifference>0)
       {
          for(size_t i=iLen; i<iDifference+iLen; i++)
              this->lpBuffer[i]=_T(' ');  // 32
       }
    }
    this->iLen=_tcslen(this->lpBuffer);
    printf("  Leaving String::Format(ssize_t)\n");
   }
   
#endif
*/
