// cl Test9.cpp /O1 /Os /GS- /link TCLib.lib kernel32.lib
#include <windows.h>
#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include <stdarg.h>
typedef SSIZE_T ssize_t;
extern "C" int _fltused=1;


struct FmtSpecs
{
 BOOL       blnRightJustified;
 int        iDummy; 
 short int  iFmtSpecPos; 
 short int  iFieldWidth;         
 short int  iType;               
 short int  iDecimalPoints;
};


size_t ParseCount(const char* pString, char cDelimiter)
{
 int iCtr=0;                        //reflects # of strings delimited
 const char* p;                     //by delimiter.

 p=pString;
 while(*p)
 {
  if(*p==cDelimiter)
     iCtr++;
  p++;
 }

 return ++iCtr;
}


void Parse(char** pStrings, const char* pDelimitedString, char cDelimiter, size_t iParseCount)
{
 char* pBuffer=(char*)malloc(strlen(pDelimitedString)+1);
 if(pBuffer)
 {
    const char* c=pDelimitedString;
    char* p=pBuffer;
    while(*c)
    {
       if(*c==cDelimiter)
          *p=0;
       else
          *p=*c;
       p++, c++;
    }
    *p=0, p=pBuffer;
    for(size_t i=0; i<iParseCount; i++)
    {
        pStrings[i]=(char*)malloc(strlen(p)+1);
        strcpy(pStrings[i],p);
        p=p+strlen(pStrings[i])+1;
    }
 }
}


int iGetFieldWidth(char* pChars, size_t iFound, BOOL blnRhtJus)
{
 char szBuffer[4];
 
 if(iFound==0)
    return 0;
 if(iFound==1 && blnRhtJus==FALSE)
    return 0;  
 memset(szBuffer,0,4);  
 if(blnRhtJus)
 {
    switch(iFound)
    {
      case 1:
        szBuffer[0]=pChars[0];
        szBuffer[1]=0;
        break;
      case 2:
        szBuffer[0]=pChars[0];
        szBuffer[1]=pChars[1];
        szBuffer[2]=0;
        break;
    } 
 }
 else
 {
    switch(iFound)
    {
      case 2:
        szBuffer[0]=pChars[1];
        szBuffer[1]=0;
        break;
      case 3:
        szBuffer[0]=pChars[1];
        szBuffer[1]=pChars[2];
        szBuffer[2]=0;
        break;
    } 
 }
 
 return atoi(szBuffer);
} 


bool blnFindFormatSpec(char* pFmtSpec, FmtSpecs& fs)
{
 if(*pFmtSpec=='-')
    fs.blnRightJustified=FALSE;
 else 
    fs.blnRightJustified=TRUE;  
 for(size_t i=0; i<7; i++)
 {
     if(strncmp(pFmtSpec+i,"u",1)==0)
     { 
        fs.iType=3;
        fs.iFieldWidth=iGetFieldWidth(pFmtSpec,i,fs.blnRightJustified);
        fs.iFmtSpecPos=i;
        return true;
     }
     if(strncmp(pFmtSpec+i,"d",1)==0)
     { 
        fs.iType=1;
        fs.iFieldWidth=iGetFieldWidth(pFmtSpec,i,fs.blnRightJustified);
        fs.iFmtSpecPos=i;
        return true;
     }
     if(strncmp(pFmtSpec+i,"Iu",2)==0)
     { 
        fs.iType=4;
        fs.iFieldWidth=iGetFieldWidth(pFmtSpec,i,fs.blnRightJustified);
        fs.iFmtSpecPos=i+1;
        return true;
     }
     if(strncmp(pFmtSpec+i,"Id",2)==0)
     { 
        fs.iType=2;
        fs.iFieldWidth=iGetFieldWidth(pFmtSpec,i,fs.blnRightJustified);
        fs.iFmtSpecPos=i+1;
        return true;
     }
     if(strncmp(pFmtSpec+i,".",1)==0)
     { 
        char szBuffer[4];
        memset(szBuffer,0,4);
        fs.iType=5;
        fs.iFieldWidth=iGetFieldWidth(pFmtSpec,i,fs.blnRightJustified);
        char* pChar;
        if(strncmp(pFmtSpec+i+2,"f",1)==0)  // it'll only be one digit then
        {
           pChar=pFmtSpec+i+1;
           szBuffer[0]=*pChar;
           szBuffer[1]=0;
           fs.iDecimalPoints=atoi(szBuffer);
           fs.iFmtSpecPos=i+2;
        }
        if(strncmp(pFmtSpec+i+3,"f",1)==0)  // it'll only be one digit then
        {
           pChar=pFmtSpec+i+1;
           szBuffer[0]=*pChar;
           szBuffer[1]=*(pChar+1);
           szBuffer[2]=0;
           fs.iDecimalPoints=atoi(szBuffer);
           fs.iFmtSpecPos=i+3;
        }
        return true;
     }
     if(strncmp(pFmtSpec+i,"f",1)==0)
     { 
        fs.iType=5;
        fs.iFieldWidth=0;
        fs.iFmtSpecPos=i;
        return true;
        
     }
     if(strncmp(pFmtSpec+i,"s",1)==0)
     { 
        fs.iType=6;
        fs.iFieldWidth=iGetFieldWidth(pFmtSpec,i,fs.blnRightJustified);
        fs.iFmtSpecPos=i;
        return true;
     }
     if(strncmp(pFmtSpec+i,"c",1)==0)
     { 
        fs.iType=7;
        fs.iFieldWidth=iGetFieldWidth(pFmtSpec,i,fs.blnRightJustified);
        fs.iFmtSpecPos=i;
        return true;
     }
 }
 
 return false;
} 


int MySPrintF(char* pBuffer, const char* pFmtStr, ...)
{
 size_t iParseCount=0,iLen=0,iStrLen=0;
 char** pFmtSpecs=NULL;
 char szBuffer[80];
 char*  pCh=NULL;
 char szTmp1[80];
 va_list args;
 FmtSpecs fs;
 
 memset(&fs,0,sizeof(fs));
 iParseCount=ParseCount(pFmtStr,'%');
 pFmtSpecs=(char**)malloc(iParseCount*sizeof(char*));
 if(pFmtSpecs)
 {
    Parse(pFmtSpecs,pFmtStr,'%',iParseCount);
    va_start(args, pFmtStr);
    for(size_t i=0; i<iParseCount; i++)
    {
        iLen=strlen(pFmtSpecs[i]);
        char* pStr=pFmtSpecs[i];
        if(i==0)
        {
           if(iLen)
              strcpy(pBuffer,pFmtSpecs[i]);
        }
        else
        {
           memset(&fs,0,sizeof(fs));
           blnFindFormatSpec(pFmtSpecs[i],fs);
           switch(fs.iType)
           {
              case 1: // %d -- 32 bit int
              {
                 itoa(va_arg(args,int),szTmp1,10);
                 iStrLen=strlen(szTmp1);
                 if(fs.iFieldWidth==0)
                 {
                    strcat(pBuffer,szTmp1);  // worked for iFieldWidth=0
                    pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                    strcat(pBuffer,pStr);
                 }                 
                 else
                 { 
                    SSIZE_T iNeeded=fs.iFieldWidth-iStrLen;
                    if(fs.blnRightJustified)
                    { 
                       memset(szBuffer,' ',iNeeded);
                       szBuffer[iNeeded]=0;
                       strcat(szBuffer,szTmp1);
                       strcat(pBuffer,szBuffer);
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);
                    }
                    else
                    {
                       strcpy(szBuffer,szTmp1);
                       for(size_t j=iStrLen; j<fs.iFieldWidth; j++)
                           szBuffer[j]=' ';
                       szBuffer[fs.iFieldWidth]=0;
                       strcat(pBuffer,szBuffer); 
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);                        
                    }                    
                 }
                 break;
              }
              case 2: // %Id -- 64 bit int
              {
                 _i64toa(va_arg(args,ssize_t),szTmp1,10);
                 iStrLen=strlen(szTmp1);
                 if(fs.iFieldWidth==0)
                 {
                    strcat(pBuffer,szTmp1);  // worked for iFieldWidth=0
                    pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                    strcat(pBuffer,pStr);
                 }
                 else
                 { 
                    SSIZE_T iNeeded=fs.iFieldWidth-iStrLen;
                    if(fs.blnRightJustified)
                    { 
                       memset(szBuffer,' ',iNeeded);
                       szBuffer[iNeeded]=0;
                       strcat(szBuffer,szTmp1);
                       strcat(pBuffer,szBuffer);
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);
                    }
                    else
                    {
                       strcpy(szBuffer,szTmp1);
                       for(size_t j=iStrLen; j<fs.iFieldWidth; j++)
                           szBuffer[j]=' ';
                       szBuffer[fs.iFieldWidth]=0;
                       strcat(pBuffer,szBuffer); 
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);                        
                    }                    
                 }                 
                 break;
              }
              case 3: // %u  -- 32 bit unsigned int
              {
                 itoa(va_arg(args,unsigned int),szTmp1,10);
                 iStrLen=strlen(szTmp1);
                 if(fs.iFieldWidth==0)
                 {
                    strcat(pBuffer,szTmp1);  // worked for iFieldWidth=0
                    pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                    strcat(pBuffer,pStr);
                 }                 
                 else
                 { 
                    SSIZE_T iNeeded=fs.iFieldWidth-iStrLen;
                    if(fs.blnRightJustified)
                    { 
                       memset(szBuffer,' ',iNeeded);
                       szBuffer[iNeeded]=0;
                       strcat(szBuffer,szTmp1);
                       strcat(pBuffer,szBuffer);
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);
                    }
                    else
                    {
                       strcpy(szBuffer,szTmp1);
                       for(size_t j=iStrLen; j<fs.iFieldWidth; j++)
                           szBuffer[j]=' ';
                       szBuffer[fs.iFieldWidth]=0;
                       strcat(pBuffer,szBuffer); 
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);                        
                    }                    
                 }
                 break;
              } 
              case 4: // %Iu  -- 64 bit unsigned int
              {
                 _ui64toa(va_arg(args,size_t),szTmp1,10);
                 iStrLen=strlen(szTmp1);
                 if(fs.iFieldWidth==0)
                 {
                    strcat(pBuffer,szTmp1);  // worked for iFieldWidth=0
                    pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                    strcat(pBuffer,pStr);
                 }
                 else
                 { 
                    SSIZE_T iNeeded=fs.iFieldWidth-iStrLen;
                    if(fs.blnRightJustified)
                    { 
                       memset(szBuffer,' ',iNeeded);
                       szBuffer[iNeeded]=0;
                       strcat(szBuffer,szTmp1);
                       strcat(pBuffer,szBuffer);
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);
                    }
                    else
                    {
                       strcpy(szBuffer,szTmp1);
                       for(size_t j=iStrLen; j<fs.iFieldWidth; j++)
                           szBuffer[j]=' ';
                       szBuffer[fs.iFieldWidth]=0;
                       strcat(pBuffer,szBuffer); 
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);                        
                    }                    
                 }
                 break;
              }              
              case 5:
              {
                 if(fs.iFieldWidth==0)
                 { 
                    FltToCh(szTmp1,va_arg(args,double),20,6,'.',false);
                    iStrLen=strlen(szTmp1);
                    for(size_t j=0; j<iStrLen; j++)
                    {
                        if(szTmp1[j]==' ')
                        { 
                           szBuffer[j]=0;        
                           break;
                        }
                        else
                           szBuffer[j]=szTmp1[j];                      
                    } 
                    strcat(pBuffer,szBuffer);
                    pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                    strcat(pBuffer,pStr);
                 }
                 else
                 {
                    if(fs.blnRightJustified==TRUE)
                       FltToCh(szTmp1,va_arg(args,double),fs.iFieldWidth+1,fs.iDecimalPoints,'.',true);
                    else
                       FltToCh(szTmp1,va_arg(args,double),fs.iFieldWidth+1,fs.iDecimalPoints,'.',false);
                    strcat(pBuffer,szTmp1);
                    pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                    strcat(pBuffer,pStr);
                 }                
                 break;
              } 
              case 6:   
              {
                 strcpy(szTmp1,va_arg(args,char*));
                 iStrLen=strlen(szTmp1);
                 if(fs.iFieldWidth==0)
                 { 
                    strcat(pBuffer,szTmp1);
                    pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                    strcat(pBuffer,pStr); 
                 }
                 else
                 {
                    SSIZE_T iNeeded=fs.iFieldWidth-iStrLen;
                    if(fs.blnRightJustified)
                    {
                       memset(szBuffer,' ',iNeeded);
                       szBuffer[iNeeded]=0;
                       strcat(szBuffer,szTmp1);
                       strcat(pBuffer,szBuffer);
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);
                    }
                    else
                    {                     
                       strcpy(szBuffer,szTmp1);
                       for(size_t j=iStrLen; j<fs.iFieldWidth; j++)
                           szBuffer[j]=' ';
                       szBuffer[fs.iFieldWidth]=0;
                       strcat(pBuffer,szBuffer); 
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);           
                    }
                 }                
                 break;
              }
              case 7:
              {
                 char c=va_arg(args,char);
                 char* pChar=&c;
                 strcpy(szTmp1,pChar);
                 iStrLen=strlen(szTmp1);
                 if(fs.iFieldWidth==0)
                 { 
                    strcat(pBuffer,szTmp1);
                    pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                    strcat(pBuffer,pStr); 
                 }
                 else
                 {
                    SSIZE_T iNeeded=fs.iFieldWidth-iStrLen;
                    if(fs.blnRightJustified)
                    {
                       memset(szBuffer,' ',iNeeded);
                       szBuffer[iNeeded]=0;
                       strcat(szBuffer,szTmp1);
                       strcat(pBuffer,szBuffer);
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);
                    }
                    else
                    {                     
                       strcpy(szBuffer,szTmp1);
                       for(size_t j=iStrLen; j<fs.iFieldWidth; j++)
                           szBuffer[j]=' ';
                       szBuffer[fs.iFieldWidth]=0;
                       strcat(pBuffer,szBuffer); 
                       pStr=pFmtSpecs[i]+fs.iFmtSpecPos+1; 
                       strcat(pBuffer,pStr);           
                    }
                 }         
                 break;
              }              
           }  // switch(fs.iType) 
        }  // end if(i==0)       
    }
    for(size_t i=0; i<iParseCount; i++)
        free(pFmtSpecs[i]);    
    free(pFmtSpecs);
 }
 
 return 0;
} 


int main()
{
 char   szBuffer[128];
 int    iFeet     = 5;
 int    iInches   = 11;
 double dblWeight = 214.54321;
 char   szName[]  = "Fred";
 
 MySPrintF
 (
   szBuffer,
   "%s Is My Name And I Weight %5.1f Pounds And Am %d Feet %d Inches Tall!\n",
   szName,
   dblWeight,
   iFeet,
   iInches
 );
 printf("%s",szBuffer);
 getchar();
 
 return 0;
}



// 1 = int; 
// 2 = __int64; 
// 3 = unsigned int; 
// 4 = unsigned __int64; 
// 5 = double; 
// 6 = string
// 7 = char

/*
Floats
==========
f
16.4f
-16.10f

ints
==========
d
10d
-10d

__int64
==========
Id
16Id
-16Id

strings
==========
s
24s
-24s

chars
==========
c
12c
-12c
*/

//MySPrintF(szBuffer,"iNumber = %2d And iInches = %d\n",iNumber,iInches);
//MySPrintF(szBuffer,"%s Is My Name And I Weight %f Pounds And Am %d Feet %d Inches Tall!\n",szName,dblWeight,iFeet,iInches);
/*
MySPrintF
(
  szBuffer,
  "My Name Is %s And I Am %Id Feet %d Inches Tall And Weight %5.1f Pounds\n",
  szName,
  iFeet,
  iInches,
  dblWeight
);
*/
